/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CreateServiceUserRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateServiceUserRequest{}

// CreateServiceUserRequest struct for CreateServiceUserRequest
type CreateServiceUserRequest struct {
	Name string `json:"name"`
	OrganizationIds []string `json:"organization_ids"`
}

// NewCreateServiceUserRequest instantiates a new CreateServiceUserRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateServiceUserRequest(name string, organizationIds []string) *CreateServiceUserRequest {
	this := CreateServiceUserRequest{}
	this.Name = name
	this.OrganizationIds = organizationIds
	return &this
}

// NewCreateServiceUserRequestWithDefaults instantiates a new CreateServiceUserRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateServiceUserRequestWithDefaults() *CreateServiceUserRequest {
	this := CreateServiceUserRequest{}
	return &this
}

// GetName returns the Name field value
func (o *CreateServiceUserRequest) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CreateServiceUserRequest) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CreateServiceUserRequest) SetName(v string) {
	o.Name = v
}

// GetOrganizationIds returns the OrganizationIds field value
func (o *CreateServiceUserRequest) GetOrganizationIds() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.OrganizationIds
}

// GetOrganizationIdsOk returns a tuple with the OrganizationIds field value
// and a boolean to check if the value has been set.
func (o *CreateServiceUserRequest) GetOrganizationIdsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OrganizationIds, true
}

// SetOrganizationIds sets field value
func (o *CreateServiceUserRequest) SetOrganizationIds(v []string) {
	o.OrganizationIds = v
}

func (o CreateServiceUserRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateServiceUserRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["organization_ids"] = o.OrganizationIds
	return toSerialize, nil
}

type NullableCreateServiceUserRequest struct {
	value *CreateServiceUserRequest
	isSet bool
}

func (v NullableCreateServiceUserRequest) Get() *CreateServiceUserRequest {
	return v.value
}

func (v *NullableCreateServiceUserRequest) Set(val *CreateServiceUserRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateServiceUserRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateServiceUserRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateServiceUserRequest(val *CreateServiceUserRequest) *NullableCreateServiceUserRequest {
	return &NullableCreateServiceUserRequest{value: val, isSet: true}
}

func (v NullableCreateServiceUserRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateServiceUserRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


